package DiffTable;

import java.util.Scanner;
import java.util.ArrayList;

// DiffTableWithMethods
// David.

public class DiffTableWithMethods
{
	// move Scanner here so available to all methods
	static Scanner scan = new Scanner( System.in);

	public static void main( String[] args)
	{
		ArrayList<Integer>		setOfValues;
		double					average;

		setOfValues = readSetOfValues();
		average = computeAverage( setOfValues);
		printTableOfDiffs( average, setOfValues);
	}

	private static ArrayList<Integer> readSetOfValues()
	{
		ArrayList<Integer> 	values;
		int					value;

		values = new ArrayList<Integer>();

		System.out.println( "Enter set of values (neg. to stop): ");
		value = scan.nextInt();
		while ( value > 0)
		{
			values.add( new Integer( value) );
			value = scan.nextInt();
		}
		return values;
	}

	private static double computeAverage( ArrayList<Integer> values)
	{
		int		sum;
		double	average;

		sum = 0;
		for ( int i = 0; i < values.size(); i++)
		{
			sum = sum + values.get(i).intValue();
		}
		average = (double) sum / values.size();
		return average;
	}

	private static void printTableOfDiffs( double average, ArrayList<Integer> values)
	{
		System.out.println();
		System.out.println( "Average = " + average);

		System.out.println( "-----------------------");
		for ( int i : values)
		{
			System.out.println( i + "\t" + (i - average) );
		}
		System.out.println( "-----------------------");
	}

}